-- config.lua
-- Dec 2016
-- Configuration Options

--------------------------------------------------------------------------------
-- Messages
--------------------------------------------------------------------------------

WELCOME_MSG_HEAD = "Welcome to "
WELCOME_MSG_TAIL = "'s Server!"
GAME_MODE_MSG = "In the current game mode, a satellite must be launched from an existing far away rocket silo to win!"
MODULES_ENABLED = "Mods Enabled: Separate Spawns, Gravestone, Long-Reach, Larger Inventory, Autofill, Better Bots"

WELCOME_MSG1 = "This server is running Oarc's PvE Wilderness Spawn Scenario."
WELCOME_MSG2 = "You spawn on diffrent locations and have to reach the silo."
WELCOME_MSG3 = "This version has some comfort bonuses for the early game."
WELCOME_MSG4 = "Read the Info & Rules on the top left corner and have fun!"

WELCOME_MSG_WARNING1 = "Please wait for 10-20 seconds when you select your first spawn."
WELCOME_MSG_WARNING2 = "Try to unpower your base on leaving, if you haven't secured it."
WELCOME_MSG6 = "Creator: SteamID: Oarc | Twitter: @_Oarc_ | oarcinae@gmail.com"
WELCOME_MSG7 = "Variant: SteamID: var_dump | Discord: Hakto#9472"

VERSION_MSG1 = "Version (0.2.9.2):"
VERSION_MSG2 = "RSO to vanilla generation for 0.15."

SPAWN_MSG1 = "Current Spawn Mode: HARDCORE WILDERNESS (Always in BETA)"
SPAWN_MSG2 = "In this mode, there is no default spawn. Everyone starts in the wild!"
SPAWN_MSG3 = "Resources are spread out far apart but are quite rich."

-- These are my specific welcome messages that get used only if I am the user
-- that creates the game.
WELCOME_MSG_OARC = "Welcome to Oarc's official server! Join the discord here: discord.gg/Wj56gkU"
WELCOME_MSG_TITLE_OARC = "Welcome to Oarc's Server"

--------------------------------------------------------------------------------
-- Modified Stuff
--------------------------------------------------------------------------------

-- Display game name in info gui (many asking the name before reconnecting)
GAME_NAME = "Game name: n/a"

MODIFIED_INFO1 = "Join the Discord channel of this server: n/a"
MODIFIED_INFO2 = "Server: n/a"

-- Rules
RULEHEADLINE = "Server Rules"
RULE1 = "1. Be polite and respectful to all players."
RULE2 = "2. Ask the owner of the base, before you change anything."
RULE3 = "3. If you join a base, don't criticize their builds."
RULE4 = "4. LHD (signals inside) preferred, but not mandatory :)"
RULE5 = "5. Do NOT concrete/pave with bots - NEVER!"
RULE6 = "6. Don't complain about lags. 99% it's your CPU or location."
RULE7 = "7. Do not grief, cheat, glitch or exploit. Ban inc.!"

-- Messages if i am host

MODIFIED_INFO1_HAKTO = "Join the Discord channel of this server: qqBfyMF"
MODIFIED_INFO2_HAKTO = "Server: OVH dedicated, Xeon 1225v2, 32GB RAM, 250Mbit Uplink"
GAME_NAME_HAKTO = "Game name: [EU] Hakto's Server (Oarc Scenario | 05.03.)"

--------------------------------------------------------------------------------
-- Module Enables
-- These enables are not fully tested! For example, disable separate spawns
-- will probably break the frontier rocket silo mode
--------------------------------------------------------------------------------

-- Frontier style rocket silo mode
FRONTIER_ROCKET_SILO_MODE = true

-- Separate spawns
ENABLE_SEPARATE_SPAWNS = true

-- Enable Scenario version of RSO
ENABLE_RSO = false

-- Enable Gravestone Chests
ENABLE_GRAVESTONE_CHESTS = true

-- Enable Undecorator
ENABLE_UNDECORATOR = true

-- Enable Tags
ENABLE_TAGS = true

-- Enable Long Reach
ENABLE_LONGREACH = true

-- Enable Autofill
ENABLE_AUTOFILL = true

-- Enable BPS
ENABLE_BLUEPRINT_STRING = false

--------------------------------------------------------------------------------
-- Additional Stuff by Hakto
--------------------------------------------------------------------------------

-- Enable Rules GUI
ENABLE_RULES = false

-- Enable Bots on game start (set items in hakto_utils)
ENABLE_KICKSTART = false

-- Enable Playerlist
ENABLE_PLAYERLIST = true

-- Enable Larger Inventory
ENABLE_LARGERINVENTORY = true
INVENTORY_BONUS = 20

-- Enable Faster Movement
ENABLE_FASTERMOVEMENT = true
MOVESPEED_BONUS = 0.2

-- Faster Bots and higher capacity to save botusage and prob lag cause
ENABLE_EFFICIENT_BOTS = true
EFFICIENT_BOTS_SPEEDBONUS = 0.2
EFFICIENT_BOTS_CAPACITYBONUS = 3

--------------------------------------------------------------------------------
-- Spawn Options
--------------------------------------------------------------------------------

---------------------------------------
-- Distance Options
---------------------------------------
-- Near Distance in chunks
NEAR_MIN_DIST = 25 --50
NEAR_MAX_DIST = 100 --125
--
-- Far Distance in chunks
FAR_MIN_DIST = 100 --50
FAR_MAX_DIST = 200 --125
--
---------------------------------------
-- Resource Options
---------------------------------------
WATER_SPAWN_OFFSET_X = -6
WATER_SPAWN_OFFSET_Y = -38
WATER_SPAWN_LENGTH = 12

-- Start resource amounts
START_STONE_AMOUNT = 2000
START_IRON_AMOUNT = 2000
START_COPPER_AMOUNT = 2000
START_COAL_AMOUNT = 2000
START_OIL_AMOUNT = 300000

-- Start resource shape
-- If this is true, it will be a circle
-- If false, it will be a square
ENABLE_RESOURCE_SHAPE_CIRCLE = true

-- Start resource position and size
-- Position is relative to player starting location
START_RESOURCE_STONE_POS_X = -27
START_RESOURCE_STONE_POS_Y = -34
START_RESOURCE_STONE_SIZE = 12

START_RESOURCE_COAL_POS_X = -27
START_RESOURCE_COAL_POS_Y = -20
START_RESOURCE_COAL_SIZE = 12

START_RESOURCE_COPPER_POS_X = -28
START_RESOURCE_COPPER_POS_Y = -3
START_RESOURCE_COPPER_SIZE = 15

START_RESOURCE_IRON_POS_X = -28
START_RESOURCE_IRON_POS_Y = 16
START_RESOURCE_IRON_SIZE = 15

START_RESOURCE_OIL_POS_X = 14
START_RESOURCE_OIL_POS_Y = -38

-- Force the land area circle at the spawn to be fully grass
ENABLE_SPAWN_FORCE_GRASS = true

---------------------------------------
-- Safe Spawn Area Options
---------------------------------------

-- Safe area has no aliens
-- +/- this in x and y direction
SAFE_AREA_CHUNK_MULT = 8
SAFE_AREA_TILE_DIST = CHUNK_SIZE*SAFE_AREA_CHUNK_MULT

-- Warning area has reduced aliens
-- +/- this in x and y direction
WARNING_AREA_TILE_DIST = CHUNK_SIZE*16

-- 1 : X (spawners alive : spawners destroyed) in this area
WARN_AREA_REDUCTION_RATIO = 15

-- Create a circle of land area for the spawn
ENFORCE_LAND_AREA_TILE_DIST = 48


---------------------------------------
-- Other Forces/Teams Options
---------------------------------------

-- I am not currently implementing other teams. It gets too complicated.
-- Enable if people can join their own teams
-- ENABLE_OTHER_TEAMS = false

-- Main force is what default players join
MAIN_FORCE = "main_force"

-- Enable if people can spawn at the main base
ENABLE_DEFAULT_SPAWN = false

-- Enable if people can allow others to join their base
ENABLE_SHARED_SPAWNS = true
MAX_ONLINE_PLAYERS_AT_SHARED_SPAWN = 3


---------------------------------------
-- Special Action Cooldowns
---------------------------------------
RESPAWN_COOLDOWN_IN_MINUTES = 20
RESPAWN_COOLDOWN_TICKS = TICKS_PER_MINUTE * RESPAWN_COOLDOWN_IN_MINUTES

-- Require playes to be online for at least 5 minutes
-- Else their character is removed and their spawn point is freed up for use
MIN_ONLIME_TIME_IN_MINUTES = 5
MIN_ONLINE_TIME = TICKS_PER_MINUTE * MIN_ONLIME_TIME_IN_MINUTES


-- Allow players to choose another spawn in the first 10 minutes
-- This does not allow creating a new spawn point. Only joining other players.
-- SPAWN_CHANGE_GRACE_PERIOD_IN_MINUTES = 10
-- SPAWN_GRACE_TIME = TICKS_PER_MINUTE * SPAWN_CHANGE_GRACE_PERIOD_IN_MINUTES


--------------------------------------------------------------------------------
-- Alien Options
--------------------------------------------------------------------------------

-- Enable/Disable enemy expansion (Applies to RSO as well!)
ENEMY_EXPANSION = false

-- Divide the alien factors by this number to reduce it (or multiply if < 1)
ENEMY_POLLUTION_FACTOR_DIVISOR = 6
ENEMY_DESTROY_FACTOR_DIVISOR = 4

--------------------------------------------------------------------------------
-- Frontier Rocket Silo Options
--------------------------------------------------------------------------------

SILO_CHUNK_DISTANCE_X = 280
SILO_DISTANCE_X = SILO_CHUNK_DISTANCE_X*CHUNK_SIZE + CHUNK_SIZE/2
SILO_DISTANCE_Y = 16

-- Should be in the middle of a chunk
SILO_POSITION = {x = SILO_DISTANCE_X, y = SILO_DISTANCE_Y}

-- If this is enabled, the static position is ignored.
ENABLE_RANDOM_SILO_POSITION = true

--------------------------------------------------------------------------------
-- Long Reach Options
--------------------------------------------------------------------------------

BUILD_DIST_BONUS = 16
REACH_DIST_BONUS = BUILD_DIST_BONUS
RESOURCE_DIST_BONUS = 2

--------------------------------------------------------------------------------
-- Autofill Options
--------------------------------------------------------------------------------

AUTOFILL_TURRET_AMMO_QUANTITY = 10

--------------------------------------------------------------------------------
-- Use rso_config and rso_resourece_config for RSO config settings
--------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- DEBUG
--------------------------------------------------------------------------------

-- DEBUG prints for me
global.oarcDebugEnabled = false
